



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】Multithreaded Python Tutorial with the “Threadworms” Demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】Multithreaded Python Tutorial with the “Threadworms” Demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:54:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>The code for this tutorial can be downloaded here:&nbsp;<a href="http://inventwithpython.com/threadworms.py" rel="external nofollow noreferrer">threadworms.py</a>&nbsp;or from&nbsp;<a href="https://github.com/asweigart/threadworms" rel="external nofollow noreferrer">GitHub</a>. This code works with&nbsp;<a href="http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/" rel="external nofollow noreferrer">Python 3 or Python 2</a>, and you need&nbsp;<a href="http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/" rel="external nofollow noreferrer">Pygame</a>&nbsp;installed as well in order to run it.</p>
<p><img referrerpolicy="no-referrer"src="http://inventwithpython.com/blog/images/threadworms_anim_small.gif?1b9ca7" /></p>
<p><a href="http://inventwithpython.com/blog/images/threadworms_anim.gif?1b9ca7" rel="external nofollow noreferrer">Click the animated gif to view a larger version.</a></p>
<p>This is a tutorial on&nbsp;<a href="https://en.wikipedia.org/wiki/Thread_(computing)" rel="external nofollow noreferrer">threads</a>&nbsp;and multithreaded programs in Python, aimed at beginning programmers. It helps if you know the&nbsp;<a href="http://www.voidspace.org.uk/python/articles/OOP.shtml" rel="external nofollow noreferrer">basics of classes</a>&nbsp;(what they are, how you define methods, and that methods always have self as the first parameter, what subclasses (i.e. child classes) are and how a method can be inherited from a parent class, etc.)&nbsp;<a href="https://en.wikibooks.org/wiki/Python_Programming/Classes" rel="external nofollow noreferrer">Here&rsquo;s a more in-depth classes tutorial.</a></p>
<p>The example used is a&nbsp;<a href="https://en.wikipedia.org/wiki/Snake_(video_game)" rel="external nofollow noreferrer">&ldquo;Nibbles&rdquo; or &ldquo;Snake&rdquo;</a>&nbsp;style clone that has multiple worms running around a grid-like field, with each worm running in a separate thread.</p>
<h2>What are threads and why are they useful?</h2>
<p>You can skip this section if you already know what threads are and just want to see how to use them in Python.</p>
<p>When you run a normal Python program, the program execution starts at the first line and goes down line by line. Loops and function calls may cause the program execution to jump around, but it is fairly easy to see from the code which line will get executed next at any given point. You can put your finger on the first line of code in the .py file on the screen, and then trace through the next lines of code that are executed. This is&nbsp;single-threaded programming.</p>
<p>However, using multiple threads is like putting a second finger down on your code. Each finger still moves the same way, but now they are executing code simultaneously.</p>
<p>Actually, they aren&rsquo;t executing simultaneously. Your two fingers are taking turns at which one executes code. Computers with multicore CPUs can actually run multiple instructions simultaneously, but there is a feature of Python programs called the&nbsp;<a href="https://en.wikipedia.org/wiki/Global_Interpreter_Lock" rel="external nofollow noreferrer">GIL (Global Interpreter Lock)</a>&nbsp;that limits a Python program to one core only.</p>
<p>The Python interpreter will run one thread for a while, and then pause it to run another thread for a while. But it does this so fast that it seems like they are running simultaneously.</p>
<p>You can start dozens or hundreds of threads in your program (that&rsquo;s a lot of fingers). This doesn&rsquo;t automatically make your programs dozens or hundreds of times faster though (all the threads are still sharing the same CPU) but it can make your program more efficient.</p>
<p>For example, say you write a function that will download a file full of names, then sorts the names, and then writes these names to a file on your computer. If there are hundreds of files your program needs to process, you would put a call to this function in a loop and it would handle each file serially: download, sort, write, download, sort, write, download, sort, write&hellip;</p>
<p>Each of these three steps use different resources on your computer: downloading uses the network connection, sorting uses the CPU, writing the file uses the hard drive. Also, there are tiny pauses within each of these steps. For example, the server you are downloading the file from may be slow and your computer&rsquo;s Internet connection has bandwidth to spare.</p>
<p>It would be better if you could call this function hundreds of times in parallel by using one thread for each file. Not only would this make better use of your bandwidth, but if some files download sooner than others, the CPU can be used to sort them while the network connection continues to work. This makes more efficient use of your computer.</p>
<h2>What makes multithreaded programming tricky?</h2>
<p>Of course, in the above case, each thread is doing its own separate thing and doesn&rsquo;t need to communicate or synchronize anything with the other threads. You could just write the simple single-threaded version of the download-sort-write program and run the program hundreds of times separately. (Though it might be a pain to type &amp; click each time to run the program each with a different file to download.)</p>
<p>Many multithreaded programs&nbsp;<em>share access to the same variables</em>, but this is where things can get tricky.</p>
<p><img referrerpolicy="no-referrer"src="http://inventwithpython.com/blog/images/threadworms_tickets.jpg?1b9ca7" /></p>
<p>Photo from&nbsp;<a href="https://secure.flickr.com/photos/bradmontgomery/6818868037/sizes/m/in/photostream/" rel="external nofollow noreferrer">Brad Montgomery</a>)</p>
<p>Here&rsquo;s a common metaphor that is used: Say you have two robot ticket sellers. Their tasks are simple:</p>
<ol><li>Ask the customer which seat they want.</li>
<li>Check a list to see if the seat is available.</li>
<li>Get the ticket for that seat.</li>
<li>Cross that seat off the list.</li></ol>
<p>A customer asks Robot A for seat 42. Robot A checks that the seat is available from the list and finds that it is, so it grabs the ticket. But before Robot A can cross the seat off the list, Robot B is asked by a different customer for seat 42. Robot B checks the list and sees that the seat is still available, so it tries to grab the ticket for the seat. But Robot B can&rsquo;t find the ticket for seat 42.&nbsp;THIS DOES NOT COMPUTE, and Robot B&rsquo;s electronic brain explodes. Robot A then crosses seat 42 off of the list.</p>
<p>The above problem happens because although the two robots (or rather, two threads) are executing independently, they are both reading and modifying a shared list (or rather, a variable). Your programs can get very hard-to-fix bugs which are also difficult to even reproduce, since Python&rsquo;s thread execution switching is&nbsp;<a href="https://en.wikipedia.org/wiki/Nondeterministic_algorithm" rel="external nofollow noreferrer">nondeterministic</a>, that is, done differently each time the program is run. We aren&rsquo;t used to having the data in variables &ldquo;magically&rdquo; change from one line to the next just because a different thread was executed in between them.</p>
<p>When the execution switches from one thread to another, this is known as a&nbsp;context switch.</p>
<p>There is also the problem of&nbsp;deadlocks, which is commonly explained using the metaphor of the&nbsp;<a href="https://en.wikipedia.org/wiki/Dining_philosophers_problem" rel="external nofollow noreferrer">Dining Philosophers</a>. Five philosophers are sitting around a circular table eating spaghetti but require two forks to do so. There is one fork between each philosopher (for a total of five forks). The method the philosophers use to eat is this:</p>
<ol><li>Philosophize for a while.</li>
<li>Pick up the fork on your left.</li>
<li>Wait until the fork on your right is available.</li>
<li>Pick up the fork on your right.</li>
<li>Eat.</li>
<li>Put the forks down.</li>
<li>Go back to step 1.</li></ol>
<p><img referrerpolicy="no-referrer"src="http://inventwithpython.com/blog/images/threadworms_dining.gif?1b9ca7" /></p>
<p>Aside from the fact that they&rsquo;ll be sharing forks with their neighbors (eww), it seems like this method will work. But sooner or later everyone at the table will end up with the fork on their left in their hand and waiting for the fork on their right. But because everyone is holding on to the fork their neighbor is waiting for and won&rsquo;t put it down until they&rsquo;ve eaten, the philosophers are in a&nbsp;<em>deadlock state</em>. They will be holding forks in their left hand but never getting a fork in their right hand, so they never eat and never put down the fork in their left hand. The philosophers all starve to death (except for Voltaire who is actually a robot. Without spaghetti, his electronic brain explodes.)</p>
<p>There is also a similar situation called a&nbsp;livelock. This is when no work gets done because the threads are too generous at making a resource available. The best metaphor of this is when two people are walking towards each other down a hall. They step to the side to let the other person walk past, but end up blocking each other. So they both step back to the other side, but end up blocking each other again. They continue doing this until they starve/electronic-brain-explode.</p>
<p>There are a few other problems that can come up with multithreaded programming such as starvation (no seriously, that&rsquo;s what it is called) and generally fall under the label of<a href="https://en.wikipedia.org/wiki/Concurrency_(computer_science)" rel="external nofollow noreferrer">&ldquo;Concurrency&rdquo;</a>&nbsp;in computer science. But we will only treat a simplified case.</p>
<h2>Locks</h2>
<p>One way to prevent bugs with multithreaded programming is by using locks. Before a thread reads or modifies a shared variable, it attempts to&nbsp;&ldquo;acquire&rdquo;&nbsp;a lock. If it can acquire the lock, the thread goes on to read or modify the variable. If the thread cannot acquire the lock, it waits until the lock becomes available.</p>
<p>When the thread is done with the shared variable, it will&nbsp;&ldquo;release&rdquo;&nbsp;the lock so that some other thread waiting for the lock can acquire it.</p>
<p>Going back to our robot ticket seller metaphor, this is like having a robot pick up the list (the list is a &ldquo;lock&rdquo;), and then reading it the ticket is available, grabbing the ticket, and then crossing out the seat on the list. When the robot puts the list back down, it is &ldquo;releasing the lock&rdquo;. If another robot needs to pick up the list but it is not there, it will wait until the list is available.</p>
<p>You can cause bugs by writing code that forgets to release a lock. This will cause a deadlock situation since the other threads will hang and do nothing while waiting for a lock to bereleased.</p>
<h2>Threads in Python</h2>
<p>Okay, let&rsquo;s write a Python program that demonstrates how to use threads and locks. This program is based off of my &ldquo;Snake&rdquo; clone in&nbsp;<a href="http://inventwithpython.com/pygame/chapter6.html" rel="external nofollow noreferrer">Chapter 6</a>&nbsp;of my&nbsp;<a href="http://inventwithpython.com/pygame/chapters" rel="external nofollow noreferrer">Making Games with Python &amp; Pygame</a>&nbsp;book. Except instead of a worm running around eating apples, we&rsquo;ll just have the worm running around the screen. And instead of just one worm, we will have multiple worms. Each worm will be controlled by a separate thread. The shared variable will have the data structure that represents which places on the screen (called &ldquo;cells&rdquo; in this program) are occupied by a worm. A worm cannot move forward to occupy a cell if another worm is already there. We will use locks to ensure that the worms don&rsquo;t occupy the same cell as another worm.</p>
<p>The code for this tutorial can be downloaded here:&nbsp;<a href="http://inventwithpython.com/threadworms.py" rel="external nofollow noreferrer">threadworms.py</a>&nbsp;or from&nbsp;<a href="https://github.com/asweigart/threadworms" rel="external nofollow noreferrer">GitHub</a>. This code works with&nbsp;<a href="http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/" rel="external nofollow noreferrer">Python 3 or Python 2</a>, and you need&nbsp;<a href="http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/" rel="external nofollow noreferrer">Pygame</a>&nbsp;installed as well in order to run it.</p>
<p>Here&rsquo;s a summary of the thread-related code in our threadworms.py program:</p>
<div>
<pre class="prettyprint linenums">import threading</pre>
</div>
<p>Python&rsquo;s thread library is in a module named&nbsp;<code>threading</code>, so first import this module.</p>
<div>
<pre class="prettyprint linenums">GRID_LOCK = threading.Lock()</pre>
</div>
<p>The class Lock in the threading module has&nbsp;<code>acquire()</code>&nbsp;and&nbsp;<code>release()</code>&nbsp;methods. We will create a new&nbsp;<code>Lock</code>&nbsp;object and store it in a global variable named&nbsp;<code>GRID_LOCK</code>. (Since the state of the grid-like screen and which cells are occupied is stored in a global variable named<code>GRID</code>. The pun was unintended.)</p>
<div>
<pre class="prettyprint linenums"># A global variable that the Worm threads check to see if they should exit.

WORMS_RUNNING = True</pre>
</div>
<p>Our&nbsp;<code>WORMS_RUNNING</code>&nbsp;global variable is regularly checked by the worm threads to see if they should quit. Calling&nbsp;<code>sys.exit()</code>&nbsp;will not stop the program because it only quits the thread that made the call. As long as there are other threads still running the program will continue. The main thread in our program (which handles the Pygame drawing and event handling) will set&nbsp;<code>WORMS_RUNNING</code>&nbsp;to&nbsp;<code>False</code>&nbsp;before it calls&nbsp;<code>pygame.quit()</code>&nbsp;and&nbsp;<code>sys.exit()</code>. The next time a thread checks&nbsp;<code>WORMS_RUNNING</code>, it will quit, until eventually the last thread quits and then the program terminates.</p>
<div>
<pre class="prettyprint linenums">class Worm(threading.Thread):<br />
    def __ init__(self, name='Worm', maxsize=None, color=None, speed=None):<br />
        threading.Thread.__init__(self)<br />
        self.name = name</pre>
</div>
<p>The thread&rsquo;s code must start from a class that is a child of the&nbsp;<code>Thread</code>&nbsp;class (which is in the<code>threading</code>&nbsp;module). Our&nbsp;<code>Thread</code>&nbsp;subclass will be named&nbsp;<code>Worm</code>&nbsp;since it controls You don&rsquo;t need an&nbsp;<code>__init__()</code>&nbsp;function, but since our Worm classes uses one we need to call the<code>threading.Thread</code>&nbsp;class&rsquo;s&nbsp;<code>__init__()</code>&nbsp;method first. Also optional is to override the name member. Our&nbsp;<code>__init__()</code>&nbsp;function uses the string&nbsp;<code>'Worm'</code>&nbsp;by default, but we can supply each thread with a unique name. Python will display the thread&rsquo;s name in the error message if it crashes.</p>
<div>
<pre class="prettyprint linenums">GRID_LOCK.acquire()<br />
# ...some code that reads or modifies GRID...<br />
GRID_LOCK.release()</pre>
</div>
<p>Before we read or modify the value in the&nbsp;<code>GRID</code>&nbsp;variable, the thread&rsquo;s code should attempt to acquire the lock. If the lock isn&rsquo;t available, the method call to&nbsp;<code>acquire()</code>&nbsp;will not return and instead&nbsp;&ldquo;block&rdquo;&nbsp;until the lock becomes available. The thread is paused while this happens. This way, we know that the code after the&nbsp;<code>acquire()</code>&nbsp;call will only happen if the thread has acquired the lock.</p>
<p>Acquiring and releasing a lock around a bit of code ensures that another thread does not execute this code while the current thread is. This makes the code&nbsp;atomic&nbsp;because the code is always executed as a single unit.</p>
<p>After the thread&rsquo;s code is done with the&nbsp;<code>GRID</code>&nbsp;variable, the lock can be released by calling the<code>release()</code>&nbsp;method.</p>
<div>
<pre class="prettyprint linenums">def run(self):<br />
    # thread code goes here.</pre>
</div>
<p>A thread starts when the&nbsp;<code>Worm</code>&nbsp;class (which is a subclass of&nbsp;<code>threading.Thread</code>) has its<code>start()</code>&nbsp;method called. We don&rsquo;t have to implement&nbsp;<code>start()</code>&nbsp;in the&nbsp;<code>Worm</code>&nbsp;class because it is inherited from the&nbsp;<code>threading.Thread</code>&nbsp;class. When the&nbsp;<code>start()</code>&nbsp;method is called, a new thread is created and the code inside the&nbsp;<code>run()</code>&nbsp;method is executed in this new thread. Do not call the&nbsp;<code>run()</code>&nbsp;method directly, as this won&rsquo;t create the new thread.</p>
<p>This is important to know: to start the thread call the&nbsp;<code>start()</code>&nbsp;method, but the code that gets run in the new thread is in&nbsp;<code>run()</code>. We don&rsquo;t have to define&nbsp;<code>start()</code>&nbsp;because it is inherited from&nbsp;<code>threading.Thread</code>. We do need to define&nbsp;<code>run()</code>&nbsp;since that is where our thread&rsquo;s code will go.</p>
<p>When the&nbsp;<code>run()</code>&nbsp;method returns (or&nbsp;<code>sys.exit()</code>&nbsp;is called in the thread), the thread will be destroyed. All threads in a program must be destroyed before the program terminates. The program will still be running as long as there is one running thread.</p>
<p>So when&nbsp;<code>start()</code>&nbsp;is called, this is when you would place your second finger on the source code in&nbsp;<code>run()</code>&nbsp;to start tracing the code. Your first finger will continue tracing the code after the line that has the&nbsp;<code>start()</code>&nbsp;call.</p>
<h2>A Simple Multithreaded Example</h2>
<p>Before we go into the Threadworm code, let&rsquo;s just look at a dead simple multithreaded program:</p>
<div>
<pre class="prettyprint linenums">import threading

TOTAL = 0

class CountThread(threading.Thread):<br />
    def run(self):<br />
        global TOTAL<br />
        for i in range(100):<br />
            TOTAL = TOTAL + 1<br />
        print('%s\n' % (TOTAL))

a = CountThread()<br />
b = CountThread()<br />
a.start()<br />
b.start()</pre>
</div>
<p>This program defines a new class called&nbsp;<code>CountThread</code>. When a&nbsp;<code>CountThread</code>&nbsp;object&rsquo;s&nbsp;<code>start()</code>method is called, a new thread is created which will loop 100 times and increment the&nbsp;<code>TOTAL</code>global variable (which is shared between the variables) by&nbsp;<code>1</code>&nbsp;on each iteration of the loop.</p>
<p>Since we are creating two&nbsp;<code>CountThread</code>&nbsp;objects, whichever one finishes last should display<code>200</code>. Each thread increases&nbsp;<code>TOTAL</code>&nbsp;by&nbsp;<code>100</code>&nbsp;and there are two threads. When we run this program, that&rsquo;s what we see:</p>
<div>
<pre class="prettyprint linenums">100<br />
200</pre>
</div>
<p>Because the first number is&nbsp;<code>100</code>, we can tell that probably what happened is that one thread ran through the entire loop before a context switch happened.</p>
<p>However, if we change&nbsp;<code>range(100)</code>&nbsp;to&nbsp;<code>range(100000)</code>, we would expect the second number to be&nbsp;<code>200000</code>, since each thread increases&nbsp;<code>TOTAL</code>&nbsp;by&nbsp;<code>100000</code>&nbsp;and there are two threads. But when we run the program, something like this appears (your numbers may be slightly different):</p>
<div>
<pre class="prettyprint linenums">143294<br />
149129</pre>
</div>
<p>That second number is not&nbsp;<code>200000</code>! It&rsquo;s quite less than that actually. The reason this happened is because we did not use locks around the code the reads and modifies the<code>TOTAL</code>&nbsp;variable, which is shared among multiple threads.</p>
<p>Look at this line:</p>
<div>
<pre class="prettyprint linenums">TOTAL = TOTAL + 1</pre>
</div>
<p>If&nbsp;<code>TOTAL</code>&nbsp;was set to&nbsp;<code>99</code>, then you would expect&nbsp;<code>TOTAL + 1</code>&nbsp;to evaluate to&nbsp;<code>99 + 1</code>&nbsp;and then to<code>100</code>, and then&nbsp;<code>100</code>&nbsp;is stored as the new value in&nbsp;<code>TOTAL</code>. Then on the next iteration,&nbsp;<code>TOTAL + 1</code>&nbsp;would be&nbsp;<code>100 + 1</code>&nbsp;or&nbsp;<code>101</code>, which is stored as the new value in&nbsp;<code>TOTAL</code>.</p>
<p>But say when&nbsp;<code>TOTAL + 1</code>&nbsp;gets evaluated as&nbsp;<code>99 + 1</code>, the execution switches to the other thread, which is also about to execute the&nbsp;<code>TOTAL = TOTAL + 1</code>&nbsp;line. The value in&nbsp;<code>TOTAL</code>&nbsp;is still<code>99</code>, so&nbsp;<code>TOTAL + 1</code>&nbsp;in this second thread gets evaluated to&nbsp;<code>99 + 1</code>.</p>
<p>Then, another context switch happens back to the first thread where TO<code>TAL = 99 + 1</code>&nbsp;is in the middle of being executed. The integer&nbsp;<code>100</code>&nbsp;is assigned to&nbsp;<code>TOTAL</code>. Now execution switches back to the second thread again.</p>
<p>In this second thread,&nbsp;<code>TOTAL = 99 + 1</code>&nbsp;is about to be executed. Even though&nbsp;<code>TOTAL</code>&nbsp;is now<code>100</code>, the&nbsp;<code>TOTAL + 1</code>&nbsp;in this second thread has already been evaluated as&nbsp;<code>99 + 1</code>. So the second thread also ends up assigning the integer&nbsp;<code>100</code>&nbsp;to&nbsp;<code>TOTAL</code>. Even though this&nbsp;<code>TOTAL = TOTAL + 1</code>&nbsp;has been executed twice (once by each thread), the value in&nbsp;<code>TOTAL</code>&nbsp;has really only been incremented by&nbsp;<code>1</code>!</p>
<p>The problem is, the line of code&nbsp;<code>TOTAL = TOTAL + 1</code>&nbsp;is not atomic. The context switch can happen right in the middle of the line being executed. We need to use locks around this code to make this an atomic operation.</p>
<p>This new code fixes this problem:</p>
<div>
<pre class="prettyprint linenums">import threading

TOTAL = 0<br />
MY_LOCK = threading.Lock()

class CountThread(threading.Thread):<br />
    def run(self):<br />
        global TOTAL<br />
        for i in range(100000):<br />
            MY_LOCK.acquire()<br />
            TOTAL = TOTAL + 1<br />
            MY_LOCK.release()<br />
        print('%s\n' % (TOTAL))

a = CountThread()<br />
b = CountThread()<br />
a.start()<br />
b.start()</pre>
</div>
<p>When we run this code, this is what is outputted (your first number might be a little different):</p>
<div>
<pre class="prettyprint linenums">199083<br />
200000</pre>
</div>
<p>That the second number is&nbsp;<code>200000</code>&nbsp;tells us that the&nbsp;<code>TOTAL = TOTAL + 1</code>&nbsp;line was correctly executed each of the 200,000 times it was run.</p>
<h2>Explaining the Threadworms Program</h2>
<p>I&rsquo;m going to use the&nbsp;<a href="http://inventwithpython.com/threadworms_nocomments.py" rel="external nofollow noreferrer">threadworms_nocomments.py</a>&nbsp;version of the program since it doesn&rsquo;t have the very verbose comments in it. The line numbers have been included at the front of each line (they are not a part of the actual Python source code). I skip a lot of the commented sections because they are self-explanatory. You don&rsquo;t really need to know Pygame to follow this code. Pygame is only responsible for creating the window and drawing the lines and rectangles on it.</p>
<p>One thing to know is that Pygame uses a tuple of three integers to represent colors. The integers each span from&nbsp;<code>0</code>&nbsp;to&nbsp;<code>255</code>&nbsp;and represent the RGB (Red-Green-Blue) value of the color. So&nbsp;<code>(0, 0, 0)</code>&nbsp;is black and&nbsp;<code>(255, 255, 255)</code>&nbsp;is white and&nbsp;<code>(255, 0, 0)</code>&nbsp;is red and&nbsp;<code>(255, 0, 255)</code>&nbsp;is purple, etc.</p>
<div>
<pre class="prettyprint linenums">  9. import random, pygame, sys, threading<br />
 10. from pygame.locals import *<br />
 11.<br />
 12. # Setting up constants<br />
 13. NUM_WORMS = 24  # the number of worms in the grid<br />
 14. FPS = 30        # frames per second that the program runs<br />
 15. CELL_SIZE = 20  # how many pixels wide and high each "cell" in the grid is<br />
 16. CELLS_WIDE = 32 # how many cells wide the grid is<br />
 17. CELLS_HIGH = 24 # how many cells high the grid is</pre>
</div>
<p>The top part of the code imports some modules our program needs and defines some constant values. Feel free to edit these constant values. Increasing or decreasing the&nbsp;<code>FPS</code>value doesn&rsquo;t change how fast the worms run around, it just changes how often the screen updates. If you set this value very low, it looks like the worms are teleporting since they move multiple spaces in between screen updates.</p>
<p><code>CELL_SIZE</code>&nbsp;is how big each square on the screen&rsquo;s grid is (in pixels). If you want to change the number of cells, modify the&nbsp;<code>CELLS_WIDE</code>&nbsp;and&nbsp;<code>CELLS_HIGH</code>&nbsp;constants.</p>
<div>
<pre class="prettyprint linenums"> 20. GRID = []<br />
 21. for x in range(CELLS_WIDE):<br />
 22.     GRID.append([None] * CELLS_HIGH)</pre>
</div>
<p>The&nbsp;<code>GRID</code>&nbsp;global variable will contain data that tracks the state of the grid. It is a simple list of lists so that&nbsp;<code>GRID[x][y]</code>&nbsp;will refer to the cell at the X and Y coordinate. (In programming, the (0, 0) origin is at the top-left corner of the screen. X increases going to the right (just like in mathematics classes) but Y increases going down.)</p>
<p>If&nbsp;<code>GRID[x][y]</code>&nbsp;is set to None, then that cell is unoccupied. Otherwise,&nbsp;<code>GRID[x][y]</code>&nbsp;will be set to an RGB triplet. (This information is used when drawing the grid to the screen.)</p>
<div>
<pre class="prettyprint linenums"> 24. GRID_LOCK = threading.Lock() # pun was not intended</pre>
</div>
<p>Line 24 creates a Lock object which our threads&rsquo; code will acquire and release before reading or modifying&nbsp;<code>GRID</code>.</p>
<div>
<pre class="prettyprint linenums"> 26. # Constants for some colors.<br />
 27. #             R    G    B<br />
 28. WHITE     = (255, 255, 255)<br />
 29. BLACK     = (  0,   0,   0)<br />
 30. DARKGRAY  = ( 40,  40,  40)<br />
 31. BGCOLOR = BLACK             # color to use for the background of the grid<br />
 32. GRID_LINES_COLOR = DARKGRAY # color to use for the lines of the grid<br />
RGB tuples are kind of hard to read, so I usually set up some constants for them.<br />
 33.<br />
 34. # Calculate total pixels wide and high that the full window is<br />
 35. WINDOWWIDTH = CELL_SIZE * CELLS_WIDE<br />
 36. WINDOWHEIGHT = CELL_SIZE * CELLS_HIGH<br />
 37.<br />
 38. UP = 'up'<br />
 39. DOWN = 'down'<br />
 40. LEFT = 'left'<br />
 41. RIGHT = 'right'</pre>
</div>
<p>Some more simple constants. I use constants like&nbsp;<code>DOWN</code>&nbsp;and&nbsp;<code>RIGHT</code>&nbsp;instead of strings like<code>'down'</code>&nbsp;and&nbsp;<code>'right'</code>&nbsp;because if I make a typo using constants (i.e.&nbsp;<code>DWON</code>) then Python will immediately crash with a&nbsp;<code>NameError</code>&nbsp;exception. This is much better than if I make a typo like<code>'dwon'</code>&nbsp;which won&rsquo;t immediately crash the program will cause bugs later on, making it more difficult to track down.</p>
<div>
<pre class="prettyprint linenums"> 43. HEAD = 0<br />
 44. BUTT = -1 # negative indexes count from the end, so -1 will always be the last index</pre>
</div>
<p>Each worm will be represent by a list of dictionaries like&nbsp;<code>{'x': 42, 'y': 7}</code>. Each of these dictionaries represents a single body segment of the worm. The dictionary at the front of the list (at index&nbsp;<code>0</code>) is the head and the dictionary at the end of the list (at index&nbsp;<code>-1</code>, using Python&rsquo;s nice negative indexing which begins counting from the end) is the butt of the worm.</p>
<p>(In computer science, &ldquo;head&rdquo; often refers to the first item in a queue or list, and &ldquo;tail&rdquo; refers to every item after the head. So I use &ldquo;butt&rdquo; to refer to just the last item. Also, I am silly.)</p>
<p><img referrerpolicy="no-referrer"src="http://inventwithpython.com/blog/images/threadworms_coordinates.png?1b9ca7" /></p>
<p>The above worm would be represented with a list that looks like this:&nbsp;<code>[{'x': 7, 'y': 2}, {'x': 7, 'y': 3}, {'x': 7, 'y': 4}, {'x': 8, 'y': 4}, {'x': 9, 'y': 4}, {'x': 10, 'y': 4}, {'x': 11, 'y': 4}, {'x': 11, 'y': 3}, {'x': 11, 'y': 2}]</code></p>
<div>
<pre class="prettyprint linenums"> 46. # A global variable that the Worm threads check to see if they should exit.<br />
 47. WORMS_RUNNING = True</pre>
</div>
<p>As long as one thread is running, the program will continue to execute. The main thread that does the screen drawing will also detect when the user has clicked the close button on the window or pressed the Esc key, so it needs a way to tell the worm threads to quit. We will code the worm threads to constantly check&nbsp;<code>WORMS_RUNNING</code>. If&nbsp;<code>WORMS_RUNNING</code>&nbsp;is set to&nbsp;<code>False</code>, then the thread will terminate itself.</p>
<div>
<pre class="prettyprint linenums"> 49. class Worm(threading.Thread): # "Thread" is a class in the "threading" module.<br />
 50.     def __init__(self, name='Worm', maxsize=None, color=None, speed=None):</pre>
</div>
<p>Here&rsquo;s our&nbsp;<code>Worm</code>&nbsp;class. It is a child class of the&nbsp;<code>threading.Thread</code>&nbsp;class. Each worm can have a name (which appears if the thread crashes, helping us identify which thread crashed), and a size, color, and speed. Default values are provided, but we can specify these ourselves if we want.</p>
<div>
<pre class="prettyprint linenums"> 56.         threading.Thread.__init__(self) # since we are overriding the Thread class, we need to first call its __init__() method.</pre>
</div>
<p>Since we are overriding the&nbsp;<code>__init__()</code>&nbsp;method, we need to call the parent classes<code>__init__()</code>&nbsp;method so that it can initialize all the thread stuff. (We don&rsquo;t need to know how it works, just remember to call it.)</p>
<div>
<pre class="prettyprint linenums"> 57.<br />
 58.         self.name = name<br />
 59.<br />
 60.         # Set the maxsize to the parameter, or to a random maxsize.<br />
 61.         if maxsize is None:<br />
 62.             self.maxsize = random.randint(4, 10)<br />
 63.<br />
 64.             # Have a small chance of a super long worm.<br />
 65.             if random.randint(0,4) == 0:<br />
 66.                 self.maxsize += random.randint(10, 20)<br />
 67.         else:<br />
 68.             self.maxsize = maxsize<br />
 69.<br />
 70.         # Set the color to the parameter, or to a random color.<br />
 71.         if color is None:<br />
 72.             self.color = (random.randint(60, 255), random.randint(60, 255), random.randint(60, 255))<br />
 73.         else:<br />
 74.             self.color = color<br />
 75.<br />
 76.         # Set the speed to the parameter, or to a random number.<br />
 77.         if speed is None:<br />
 78.             self.speed = random.randint(20, 500) # wait time before movements will be between 0.02 and 0.5 seconds<br />
 79.         else:<br />
 80.             self.speed = speed</pre>
</div>
<p>The above code sets up a worm with random values for the size, color, and speed unless specific values were specified for the parameters.</p>
<div>
<pre class="prettyprint linenums"> 82.         GRID_LOCK.acquire() # block until this thread can acquire the lock<br />
 83.<br />
 84.         while True:<br />
 85.             startx = random.randint(0, CELLS_WIDE - 1)<br />
 86.             starty = random.randint(0, CELLS_HIGH - 1)<br />
 87.             if GRID[startx][starty] is None:<br />
 88.                 break # we've found an unoccupied cell in the grid<br />
 89.<br />
 90.         GRID[startx][starty] = self.color # modify the shared data structure<br />
 91.<br />
 92.         GRID_LOCK.release()</pre>
</div>
<p>We need to determine a random starting location for the worm. To make this easier, all worms begin with a length of one body segment and grow until they reach their full maximum size. But we need to make sure that the random location on the grid we come up with isn&rsquo;t already occupied. This involves reading and modifying the&nbsp;<code>GRID</code>&nbsp;global variable, so we need to acquire and release the&nbsp;<code>GRID_LOCK</code>&nbsp;lock before doing this.</p>
<p>(As a side note, you might be wondering why we don&rsquo;t have a &ldquo;global GRID&rdquo; line at the beginning of this method.&nbsp;<code>GRID</code>&nbsp;is a global variable and we are modifying it in this method, and without a&nbsp;<code>global</code>&nbsp;statement Python should consider this a local variable that just happens to have the same name as the&nbsp;<code>GRID</code>&nbsp;global variable. But if you look closer, we only change values inside the&nbsp;<code>GRID</code>&nbsp;list of lists, but never the value in&nbsp;<code>GRID</code>&nbsp;itself. That is, we have code that looks like &ldquo;<code>GRID[startx][starty] = self.color</code>&rdquo; but never &ldquo;<code>GRID = someValue</code>&ldquo;. Because we don&rsquo;t actually modify&nbsp;<code>GRID</code>&nbsp;itself, Python considers the use of the variable name<code>GRID</code>&nbsp;in this method to refer to the global variable&nbsp;<code>GRID</code>.)</p>
<p>We keep looping until we&rsquo;ve found an unoccupied cell, and then mark that cell as now occupied. After this, we are done reading and modifying&nbsp;<code>GRID</code>&nbsp;so we release the&nbsp;<code>GRID_LOCK</code>lock.</p>
<p>(Another side note, if there are no free cells on the grid, this loop will continue to loop forever and the thread will &ldquo;hang&rdquo;. Since the other threads will continue to run, you might not notice this problem. The new worm will not be created but the rest of the program continues to run normally. However, when you try to quit, since the hanging thread never gets to check<code>WORMS_RUNNING</code>&nbsp;to know it should quit and the program will refuse to terminate. You will have to force the program to shut down through your operating system. Just be sure not to add more worms than you have space for.)</p>
<div>
<pre class="prettyprint linenums"> 96.         self.body = [{'x': startx, 'y': starty}]<br />
 97.         self.direction = random.choice((UP, DOWN, LEFT, RIGHT))</pre>
</div>
<p>The starting body segment is added to the&nbsp;<code>body</code>&nbsp;member variable. The&nbsp;<code>body</code>&nbsp;member variable will be a list of all the locations of segments of the body. The direction that the worm is heading in is stored in the&nbsp;<code>direction</code>&nbsp;member variable.</p>
<p>Technically, since this worm right now only has one body segment that is both the first and last item in the list, the worm&rsquo;s head is the same as its butt.</p>
<div>
<pre class="prettyprint linenums">100.     def run(self):<br />
101.         while True:<br />
102.             if not WORMS_RUNNING:<br />
103.                 return # A thread terminates when run() returns.</pre>
</div>
<p>The&nbsp;<code>run()</code>&nbsp;method is the method that is called when the worm&rsquo;s&nbsp;<code>start()</code>&nbsp;method is called. The code in&nbsp;<code>run()</code>&nbsp;is executed in a brand new thread. We will have an infinite loop that causes the worm to continuously move around the grid. The first thing we do on each iteration of the loop is check if&nbsp;<code>WORMS_RUNNING</code>&nbsp;is set to&nbsp;<code>False</code>, and if so, we should return from this method.</p>
<p>The thread will terminate itself if we either call&nbsp;<code>sys.exit()</code>&nbsp;from the thread or when the<code>run()</code>&nbsp;method returns.</p>
<div>
<pre class="prettyprint linenums">105.             # Randomly decide to change direction<br />
106.             if random.randint(0, 100) &lt; 20: # 20% to change direction<br />
107.                 self.direction = random.choice((UP, DOWN, LEFT, RIGHT))</pre>
</div>
<p>On each move, there&rsquo;s a 20% chance that the worm randomly changes direction. (Although the new direction could be the same as the current direction. But I wanted to write this code out quickly.)</p>
<div>
<pre class="prettyprint linenums">109.             GRID_LOCK.acquire() # don't return (that is, block) until this thread can acquire the lock<br />
110.<br />
111.             nextx, nexty = self.getNextPosition()<br />
112.             if nextx in (-1, CELLS_WIDE) or nexty in (-1, CELLS_HIGH) or GRID[nextx][nexty] is not None:<br />
113.                 # The space the worm is heading towards is taken, so find a new direction.<br />
114.                 self.direction = self.getNewDirection()<br />
115.<br />
116.                 if self.direction is None:<br />
117.                     # No places to move, so try reversing our worm.<br />
118.                     self.body.reverse() # Now the head is the butt and the butt is the head. Magic!<br />
119.                     self.direction = self.getNewDirection()<br />
120.<br />
121.                 if self.direction is not None:<br />
122.                     # It is possible to move in some direction, so reask for the next postion.<br />
123.                     nextx, nexty = self.getNextPosition()<br />
124.<br />
125.             if self.direction is not None:<br />
126.                 # Space on the grid is free, so move there.<br />
127.                 GRID[nextx][nexty] = self.color # update the GRID state<br />
128.                 self.body.insert(0, {'x': nextx, 'y': nexty}) # update this worm's own state<br />
129.<br />
130.                 # Check if we've grown too long, and cut off tail if we have.<br />
131.                 # This gives the illusion of the worm moving.<br />
132.                 if len(self.body) &gt; self.maxsize:<br />
133.                     GRID[self.body[BUTT]['x']][self.body[BUTT]['y']] = None # update the GRID state<br />
134.                     del self.body[BUTT] # update this worm's own state (heh heh, worm butt)<br />
135.             else:<br />
136.                 self.direction = random.choice((UP, DOWN, LEFT, RIGHT)) # can't move, so just do nothing for now but set a new random direction<br />
137.<br />
138.             GRID_LOCK.release()</pre>
</div>
<p>The above code handles moving the worm one space. Since this involves reading and modifying&nbsp;<code>GRID</code>, we need to acquire the&nbsp;<code>GRID_LOCK</code>&nbsp;lock first. Essentially, the worm will try to move one space in the direction that it&rsquo;s direction member variable says. If this cell is beyond the border of the grid or is already occupied, then the worm will change its direction. If the worm is blocked on all sides, then the worm reverses itself so that the butt becomes the head and the head becomes the butt. If the worm still can&rsquo;t move in any direction, then it will just stay put for now.</p>
<div>
<pre class="prettyprint linenums">140.             pygame.time.wait(self.speed)</pre>
</div>
<p>After the worm has moved one space (or at least tried to), we will put the thread to sleep. Pygame has a function called&nbsp;<code>wait()</code>&nbsp;that does the same thing as&nbsp;<code>time.sleep()</code>, except that the argument to&nbsp;<code>wait()</code>&nbsp;is in integer of milliseconds instead of seconds.</p>
<p>Pygame&rsquo;s&nbsp;<code>pygame.time.wait()</code>&nbsp;and the Python Standard Library&rsquo;s&nbsp;<code>time.time()</code>&nbsp;functions (and Pygame&rsquo;s&nbsp;<code>tick()</code>&nbsp;method) are smart enough to tell the operating system to put the thread to sleep for a while and just run other threads instead. Of course, while the OS could interrupt our thread at any time to hand execution off to a different thread, calling&nbsp;<code>wait()</code>&nbsp;or&nbsp;<code>sleep()</code>is a way we can explicitly say, &ldquo;Go ahead and don&rsquo;t run this thread for X milliseconds.&rdquo;</p>
<p>This wouldn&rsquo;t happen if we have &ldquo;wait&rdquo; code like this:</p>
<div>
<pre class="prettyprint linenums">startOfWait = time.time()<br />
while time.time() - 5 &gt; startOfWait:<br />
    pass # do nothing for 5 seconds</pre>
</div>
<p>The above code also implements &ldquo;waiting&rdquo;, but to the OS it looks like your thread is still executing code (even though this code is doing nothing but looping until 5 seconds has passed). This is inefficient, because time spent executing the above pointless loop is time that could have been spent executing other thread&rsquo;s code.</p>
<p>Of course, if ALL worms&rsquo; threads are sleeping, then the computer can know it can use the CPU to run other programs besides our Python Threadworms script.</p>
<div>
<pre class="prettyprint linenums">143.     def getNextPosition(self):<br />
144.         # Figure out the x and y of where the worm's head would be next, based<br />
145.         # on the current position of its "head" and direction member.<br />
146.<br />
147.         if self.direction == UP:<br />
148.             nextx = self.body[HEAD]['x']<br />
149.             nexty = self.body[HEAD]['y'] - 1<br />
150.         elif self.direction == DOWN:<br />
151.             nextx = self.body[HEAD]['x']<br />
152.             nexty = self.body[HEAD]['y'] + 1<br />
153.         elif self.direction == LEFT:<br />
154.             nextx = self.body[HEAD]['x'] - 1<br />
155.             nexty = self.body[HEAD]['y']<br />
156.         elif self.direction == RIGHT:<br />
157.             nextx = self.body[HEAD]['x'] + 1<br />
158.             nexty = self.body[HEAD]['y']<br />
159.         else:<br />
160.             assert False, 'Bad value for self.direction: %s' % self.direction<br />
161.<br />
162.         return nextx, nexty</pre>
</div>
<p>The&nbsp;<code>getNextPosition()</code>&nbsp;figures out where the worm will go next given the position of its head and the direction it is going.</p>
<div>
<pre class="prettyprint linenums">165.     def getNewDirection(self):<br />
166.         x = self.body[HEAD]['x'] # syntactic sugar, makes the code below more readable<br />
167.         y = self.body[HEAD]['y']<br />
168.<br />
169.         # Compile a list of possible directions the worm can move.<br />
170.         newDirection = []<br />
171.         if y - 1 not in (-1, CELLS_HIGH) and GRID[x][y - 1] is None:<br />
172.             newDirection.append(UP)<br />
173.         if y + 1 not in (-1, CELLS_HIGH) and GRID[x][y + 1] is None:<br />
174.             newDirection.append(DOWN)<br />
175.         if x - 1 not in (-1, CELLS_WIDE) and GRID[x - 1][y] is None:<br />
176.             newDirection.append(LEFT)<br />
177.         if x + 1 not in (-1, CELLS_WIDE) and GRID[x + 1][y] is None:<br />
178.             newDirection.append(RIGHT)<br />
179.<br />
180.         if newDirection == []:<br />
181.             return None # None is returned when there are no possible ways for the worm to move.<br />
182.<br />
183.         return random.choice(newDirection)</pre>
</div>
<p>The&nbsp;<code>getNewDirection()</code>&nbsp;method returns a direction (one of the&nbsp;<code>UP</code>,&nbsp;<code>DOWN</code>,&nbsp;<code>LEFT</code>, or&nbsp;<code>RIGHT</code>strings) that is for an unoccupied cell within the grid. If there are no available cells the head could move towards, the method returns None.</p>
<div>
<pre class="prettyprint linenums">185. def main():<br />
186.     global FPSCLOCK, DISPLAYSURF<br />
187.<br />
188.     # Draw some walls on the grid<br />
189.     squares = """<br />
190. ...........................<br />
191. ...........................<br />
192. ...........................<br />
193. .H..H..EEE..L....L.....OO..<br />
194. .H..H..E....L....L....O..O.<br />
195. .HHHH..EE...L....L....O..O.<br />
196. .H..H..E....L....L....O..O.<br />
197. .H..H..EEE..LLL..LLL...OO..<br />
198. ...........................<br />
199. .W.....W...OO...RRR..MM.MM.<br />
200. .W.....W..O..O..R.R..M.M.M.<br />
201. .W..W..W..O..O..RR...M.M.M.<br />
202. .W..W..W..O..O..R.R..M...M.<br />
203. ..WW.WW....OO...R.R..M...M.<br />
204. ...........................<br />
205. ...........................<br />
206. """<br />
207.     #setGridSquares(squares)</pre>
</div>
<p>The&nbsp;<code>setGridSquares()</code>&nbsp;function can be used to draw static blocks on the grid by passing a multiline string. The period characters represent no change, a space character means &ldquo;set this to be unoccupied&rdquo; and any other character will represent a static block to place on the grid. You can uncomment line 207 if you want to see the &ldquo;Hello worm&rdquo; text written out in blocks.</p>
<div>
<pre class="prettyprint linenums">209.     # Pygame window set up.<br />
210.     pygame.init()<br />
211.     FPSCLOCK = pygame.time.Clock()<br />
212.     DISPLAYSURF = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT))<br />
213.     pygame.display.set_caption('Threadworms')</pre>
</div>
<p>This is standard Pygame setup code to create a window for our program.</p>
<div>
<pre class="prettyprint linenums">215.     # Create the worm objects.<br />
216.     worms = [] # a list that contains all the worm objects<br />
217.     for i in range(NUM_WORMS):<br />
218.         worms.append(Worm())<br />
219.         worms[-1].start() # Start the worm code in its own thread.</pre>
</div>
<p>This code creates the&nbsp;<code>Worm</code>&nbsp;objects and then creates their threads by calling the&nbsp;<code>start()</code>method. The code in each worm&rsquo;s&nbsp;<code>run()</code>&nbsp;method will begin executing in a separate thread at this point.</p>
<div>
<pre class="prettyprint linenums">221.     while True: # main game loop<br />
222.         handleEvents()<br />
223.         drawGrid()<br />
224.<br />
225.         pygame.display.update()<br />
226.         FPSCLOCK.tick(FPS)</pre>
</div>
<p>The main game loop is pretty simple. The&nbsp;<code>handleEvents()</code>&nbsp;function will be checking if the user is terminating the program and the&nbsp;<code>drawGrid()</code>&nbsp;function will draw the grid lines and cells to the screen. The&nbsp;<code>pygame.display.update()</code>&nbsp;function tells the window to update the screen, after which the&nbsp;<code>tick()</code>&nbsp;method will pause for however long is needed to achieve the framerate specified in&nbsp;<code>FPS</code>.</p>
<div>
<pre class="prettyprint linenums">229. def handleEvents():<br />
230.     # The only event we need to handle in this program is when it terminates.<br />
231.     global WORMS_RUNNING<br />
232.<br />
233.     for event in pygame.event.get(): # event handling loop<br />
234.         if (event.type == QUIT) or (event.type == KEYDOWN and event.key == K_ESCAPE):<br />
235.             WORMS_RUNNING = False # Setting this to False tells the Worm threads to exit.<br />
236.             pygame.quit()<br />
237.             sys.exit()</pre>
</div>
<p>The Pygame events can tell us when the user has pressed the Esc key or clicked on the close button for the window. In this case we want to set&nbsp;<code>WORMS_RUNNING</code>&nbsp;to&nbsp;<code>False</code>&nbsp;so that the threads will terminate themselves and then the main thread shuts down Pygame and exits.</p>
<div>
<pre class="prettyprint linenums">240. def drawGrid():<br />
241.     # Draw the grid lines.<br />
242.     DISPLAYSURF.fill(BGCOLOR)<br />
243.     for x in range(0, WINDOWWIDTH, CELL_SIZE): # draw vertical lines<br />
244.         pygame.draw.line(DISPLAYSURF, GRID_LINES_COLOR, (x, 0), (x, WINDOWHEIGHT))<br />
245.     for y in range(0, WINDOWHEIGHT, CELL_SIZE): # draw horizontal lines<br />
246.         pygame.draw.line(DISPLAYSURF, GRID_LINES_COLOR, (0, y), (WINDOWWIDTH, y))</pre>
</div>
<p>This code draws the screen based on the values in&nbsp;<code>GRID</code>. But first it draws the grid lines.</p>
<div>
<pre class="prettyprint linenums">248.     # The main thread that stays in the main loop (which calls drawGrid) also<br />
249.     # needs to acquire the GRID_LOCK lock before modifying the GRID variable.<br />
250.     GRID_LOCK.acquire()<br />
251.<br />
252.     for x in range(0, CELLS_WIDE):<br />
253.         for y in range(0, CELLS_HIGH):<br />
254.             if GRID[x][y] is None:<br />
255.                 continue # No body segment at this cell to draw, so skip it<br />
256.<br />
257.             color = GRID[x][y] # modify the GRID data structure<br />
258.<br />
259.             # Draw the body segment on the screen<br />
260.             darkerColor = (max(color[0] - 50, 0), max(color[1] - 50, 0), max(color[2] - 50, 0))<br />
261.             pygame.draw.rect(DISPLAYSURF, darkerColor, (x * CELL_SIZE,     y * CELL_SIZE,     CELL_SIZE,     CELL_SIZE    ))<br />
262.             pygame.draw.rect(DISPLAYSURF, color,       (x * CELL_SIZE + 4, y * CELL_SIZE + 4, CELL_SIZE - 8, CELL_SIZE - 8))<br />
263.<br />
264.     GRID_LOCK.release() # We're done messing with GRID, so release the lock.</pre>
</div>
<p>Because this code reads the&nbsp;<code>GRID</code>&nbsp;variable, we will first acquire the&nbsp;<code>GRID_LOCK</code>&nbsp;lock. If a cell is occupied (that is, it is set to an RGB tuple value inside the&nbsp;<code>GRID</code>&nbsp;variable) the code draws in the cell.</p>
<div>
<pre class="prettyprint linenums">267. def setGridSquares(squares, color=(192, 192, 192)):<br />
268.     # squares is set to a value like:<br />
269.     # """<br />
270.     # ......<br />
271.     # ...XX.<br />
272.     # ...XX.<br />
273.     # ......<br />
274.     # """<br />
275.<br />
276.     squares = squares.split('\n')<br />
277.     if squares[0] == '':<br />
278.         del squares[0]<br />
279.     if squares[-1] == '':<br />
280.         del squares[-1]<br />
281.<br />
282.     GRID_LOCK.acquire()<br />
283.     for y in range(min(len(squares), CELLS_HIGH)):<br />
284.         for x in range(min(len(squares[y]), CELLS_WIDE)):<br />
285.             if squares[y][x] == ' ':<br />
286.                 GRID[x][y] = None<br />
287.             elif squares[y][x] == '.':<br />
288.                 pass<br />
289.             else:<br />
290.                 GRID[x][y] = color<br />
291.     GRID_LOCK.release()</pre>
</div>
<p>The setGridSquares() can write static blocks to the grid and was explained previously.</p>
<div>
<pre class="prettyprint linenums">294. if __name__ == '__main__':<br />
295.     main()</pre>
</div>
<p>SummaryThe above is a Python trick. Instead of putting the main code in the global scope, we put it into a function named&nbsp;<code>main()</code>&nbsp;which is called from the bottom. This guarantees that all the functions have been defined before the code in&nbsp;<code>main()</code>&nbsp;runs. The&nbsp;<code>__name__</code>&nbsp;variable is only set to the string&nbsp;<code>'__main__'</code>&nbsp;if this program was run itself, as opposed to imported as a module by another program.</p>
<p>That&rsquo;s it! Multithreaded programming is fairly simple to explain, but it can be tricky to understand how to get your own multithreaded programs to work correctly. The best way to learn is to practice by writing your own programs.</p>
<p>Actually, the way we have our code set up, even if we got rid of the locks it would still run almost perfectly. Nothing would crash, although there would sometimes be the case where two worms are approaching the same cell and end up both occupying it. They would then seemingly move through each other. Using locks ensures that only one worm can occupy a cell at any time.</p>
<p>Good luck!</p>
<p><img referrerpolicy="no-referrer"src="http://inventwithpython.com/blog/images/threadworms_screenshot.png?1b9ca7" /></p>
<p>原文出处：<a href="http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/" rel="external nofollow noreferrer">http://inventwithpython.com/blog/2013/04/22/multithreaded-python-tutorial-with-threadworms/</a></p>
<p>译文链接：<a href="http://www.cnblogs.com/rrxc/p/4112930.html" rel="external nofollow noreferrer">http://www.cnblogs.com/rrxc/p/4112930.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mnxx0q.html">HTML中为何p标签内不可包含div标签&quest;那哪些块元素里面不能放哪些块元素呢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2jdll8.html">Hibernate之缓存的原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdplpzq.html">4 Best Time to Buy and Sell Stock III&lowbar;Leetcode</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z33rxq.html">java注解&lpar;Annotation&rpar;解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m57w2q.html">P1093 奖学金</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw26myq.html">Java 集合系列09之 Map架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8om3dxq.html">&lbrack;Tips&rsqb; Useful link &period;&period;&period; on going</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn26rv8.html">Linux忘记密码的解救方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zpyr29.html">Cubietruck查看CPU及硬盘温度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w2033q.html">把只包含因子2、3和5的数称作丑数（Ugly Number）。例如6、8都是丑数，但14不是，因为它包含因子7。 习惯上我们把1当做是第一个丑数。求按从小到大的顺序的第N个丑数。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0lyvgq.html">win7关机命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv340xq.html">写的非常好的文章  C&num;中的委托，匿名方法和Lambda表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok2jke9.html">&lbrack;Practical Git&rsqb; Compare file changes with git diff</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x6gkz9.html">SQL SERVER 与ACCESS、EXCEL的数据导入导出转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y274jq.html">MVC中Area的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmr4519.html">Swift - 39 - 枚举类型关联默认值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyeo6k9.html">Outlook Anywhere 每次要输入密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jze7eg8.html">AI 人工智能 探索 （五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjn2pr8.html">pmap 命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25gz0oq.html">sql   job定时备份数据库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j04yx0q.html">ubantu-命令-进入超级用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m5x6kq.html">js 超级玛丽&lpar;未完成&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmrmm09.html">编写可维护的javascript代码---开篇（介绍自动报错的插件）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1g1gz9.html">Google Protocal Buffer</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn325z8.html">&period;net反射详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd7v6dq.html">COS访谈第十八期：陈天奇</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmr1319.html">Color the ball</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1g5me9.html">【HDOJ】1329 Hanoi Tower Troubles Again&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0o2nlq.html">Android的JNI开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wz2oxq.html">&lbrack;Design Pattern&rsqb; Singleton Pattern 简单案例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
